//
// Computergraphik I
// Prof. Dr. Juergen Doellner
// Sommersemester 2001
// 
// Rahmenprogramm fuer Aufgabenzettel 4
//

// Stephan Brumme, 702544
// last changes: May 20, 2001


#ifndef CG_TESSELATOR_H
#define CG_TESSELATOR_H

#include "cgapplication.h"

class CGTessellator : public CGApplication {
public:
    CGTessellator();
    ~CGTessellator();

    virtual void defineStar();

    virtual void onInit();
    virtual void onDraw();
    virtual void onSize(unsigned int newWidth, unsigned int newHeight);
    virtual void onKey(unsigned char key);
    virtual void onButton(MouseButton button, MouseButtonEvent event, int x, int y);

private:
    // zeichnet das Polygon mit den GLU-Routinen
    void drawPolygon();

    // GLUtesselator Objekt
    GLUtesselator* tobj_;

    // Hilfsklasse fuer Punkte
    class Point {
    public:
        Point(double x = 0, double y = 0) {
            dta_[0] = x;
            dta_[1] = y;
            dta_[2] = 0;
        }        
        GLdouble dta_[3];
    };

    // interne Arrays zum speichern der Punkte und
    // der Konturen
    Point pts_[1000];       // alle Punkte
    int pos_;               // Array-Position in pts_
    int contourSize_[50];   // Anzahl der Punkte innerhalb einer Kontur
    int contours_;          // Anzahl der Konturen 
        
};

#endif // CG_TESSELATOR_H
