// Computergraphik I
// Prof. Dr. Juergen Doellner
// Sommersemester 2001
// 
// Rahmenprogramm fuer Aufgabenzettel 3

// Stephan Brumme, 702544
// last changes: May 12, 2001

#include "cgraster.h"
#include <memory.h>
#include "gl/gl.h"


CGRaster::CGRaster(int width, int height) {
    // speichern von width und height 
    // in Objektvariablen

	// berprfen, ob Ausmae vernnftig sind
	if (width  <= 0 || width  > MAXWIDTH)
		width  = MAXWIDTH;
	if (height <= 0 || height > MAXHEIGHT)
		height = MAXHEIGHT;

	m_nWidth = width;
	m_nHeight = height;

    // anlegen des bool-Arrays    
	m_arBuffer = new bool[m_nWidth*m_nHeight];
    
	// loeschen des Arrays
    clear();
}


CGRaster::~CGRaster() {  
	// Rasterspeicher freigeben
	delete [] m_arBuffer;
}


int CGRaster::width() const {    
    return m_nWidth;
}


int CGRaster::height() const {    
    return m_nHeight;
}


void CGRaster::clear() {
    // setzten aller Werte des bool-Arrays auf false  
	memset(m_arBuffer, false, sizeof(bool)*m_nWidth*m_nHeight);
}


bool CGRaster::getPixel(int x, int y) const {
    // liegen Koordinaten innerhalb des Rasters ?
	if (x<0 || x>=m_nWidth ||
		y<0 || y>=m_nHeight)
		return false;

	// Punkt zurckgeben
    return m_arBuffer[x+y*m_nWidth];
}


void CGRaster::setPixel(int x, int y) {    
    // liegen Koordinaten innerhalb des Rasters ?
	if (x<0 || x>=m_nWidth ||
		y<0 || y>=m_nHeight)
		return;

	// Punkt setzen
	m_arBuffer[x+y*m_nWidth] = true;
}


void CGRaster::draw() const {
    // zeichnen aller Pixel, die gesetzt sind

	// Umgebung sichern
	glPushAttrib(GL_CURRENT_BIT);

	// schwarz
	glColor3f(0.0, 0.0, 0.0);

	// alle Punkte des Rasters durchlaufen
	int x,y;
	for (x=0; x<m_nWidth; x++)
		for (y=0; y<m_nHeight; y++)
			// ggf. Rechteck mit Seitenlnge 1 zeichnen, im Zentrum liegt (x,y)
			if (getPixel(x,y))
				glRectf(x-0.5, y-0.5, x+0.5, y+0.5);


    // zeichnen der Raster-Linien
    glColor3f(0.7, 0.7, 0.7);
	glBegin(GL_LINES);
	// vertikal
	for (x=0; x<m_nWidth; x++)
	{
		glVertex2f(x+0.5, 0);
		glVertex2f(x+0.5, m_nWidth);
	}

	// horizontal
	for (y=0; y<m_nHeight; y++)
	{
		glVertex2f(0, y+0.5);
		glVertex2f(m_nHeight, y+0.5);
	}
	glEnd();

	glPopMatrix();
}